package easss.step6;

import cartago.*;
import java.math.BigDecimal;

public class Barrier extends Artifact {

	private int nBarrierParticipants;
	
    void init() {
    	nBarrierParticipants = 0;
	}
    
    @OPERATION void setupBarrier(int nParticipants){
    	nBarrierParticipants = nParticipants;
    }
    
    @OPERATION void hitAndWaitForAll(){
    	nBarrierParticipants--;
    	await("allArrived");
    }
    
    @GUARD boolean allArrived(){
    	return nBarrierParticipants == 0;
    }
}



